SystemOrganization addCategory: #'PetitDelphi-Core'!
SystemOrganization addCategory: #'PetitDelphi-Tests'!
SystemOrganization addCategory: #'PetitDelphi-AST'!

PPCompositeParser subclass: #PPDelphiAssemblyParser
	instanceVariableNames: 'keywords'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitDelphi-Core'!

!PPDelphiAssemblyParser methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 9/19/2012 14:48'!
initialize

	super initialize.
	
	self initializeKeywords.
	self initializeOperators.
	self initializeSeparators! !

!PPDelphiAssemblyParser methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 9/19/2012 14:54'!
initializeKeywords
	| values |
	keywords := Dictionary new.
	values := #( 'lock' 'repne' 'repnz' 'rep' 'repe' 'repz' 'cs' 'ds' 'es' 'fs' 'gs' 'ss' 'bx' 'ebp' 'al' 'bl' 'cl' 'dl' 'ah' 'bh' 'ch' 'dh' 'ax' 'bx' 'cx' 'dx' 'si' 'di' 'sp' 'bp' 'esp' 'eax' 'ebx' 'ecx' 'edx' 'esi' 'edi' 'mm0' 'mm1' 'mm2' 'mm3' 'mm4' 'mm5' 'mm6' 'mm7' 'xmm0' 'xmm1' 'xmm2' 'xmm3' 'xmm4' 'xmm5' 'xmm6' 'xmm7' '2' '4' '8').
	
	values do: [:eachKeyword |
		keywords at: eachKeyword 
			put: (PPUnresolvedParser named: ('keyword', eachKeyword first asUppercase asString , eachKeyword allButFirst))		
		].
	
	keywords keysAndValuesDo:  [:key :value |
		(keywords at: key) def: (key asParser ,  #word asParser not)]! !

PPCompositeParser subclass: #PPDelphiLexicon
	instanceVariableNames: 'input inputElements sub inputElement whiteSpace comment delphiToken delphiComment cComment keyword keywords separators operators stringLiteral stringCharacters stringCharacter controlChar quotedStringLiteral controlStringLiteral'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitDelphi-Core'!

!PPDelphiLexicon class methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 11:32'!
ignoredNames
	"Answer a collection of instance-variables that should not be automatically initialized with productions, but that are used internal to the composite parser."
	| newArray |	
	newArray := Array new: ((self namesToIgnore size) + (super ignoredNames size)).
	newArray
		replaceFrom: 1
		to: self namesToIgnore size
		with: self namesToIgnore.
	newArray
		replaceFrom: (self namesToIgnore size + 1)
		to: newArray size
		with: super ignoredNames.	
	^newArray! !

!PPDelphiLexicon class methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 11:31'!
namesToIgnore
	^#('keywords' 'operators' 'separators')! !

!PPDelphiLexicon methodsFor: 'utility' stamp: 'DiegoLont 9/6/2012 11:33'!
asToken: aParser
	^aParser delphiToken! !

!PPDelphiLexicon methodsFor: 'grammar-input' stamp: 'DiegoLont 9/6/2012 11:42'!
cComment
	^'/*' asParser, '*/' asParser negate star, '*/' asParser! !

!PPDelphiLexicon methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 11:08'!
comment
	^delphiComment / cComment! !

!PPDelphiLexicon methodsFor: 'grammar-input' stamp: 'DiegoLont 9/13/2012 14:15'!
controlChar
	^($# asParser, #digit asParser plus) / ('#$' asParser, #hex asParser plus)! !

!PPDelphiLexicon methodsFor: 'grammar-input' stamp: 'DiegoLont 9/13/2012 14:17'!
controlStringLiteral
	^controlChar plus! !

!PPDelphiLexicon methodsFor: 'grammar-input' stamp: 'DiegoLont 9/6/2012 11:42'!
delphiComment
	^${ asParser, $} asParser negate star, $} asParser! !

!PPDelphiLexicon methodsFor: 'grammar-input' stamp: 'DiegoLont 9/6/2012 11:19'!
delphiToken
	^keyword! !

!PPDelphiLexicon methodsFor: 'initialization' stamp: 'DiegoLont 9/6/2012 12:21'!
initialize

	super initialize.
	
	self initializeKeywords.
	self initializeOperators.
	self initializeSeparators! !

!PPDelphiLexicon methodsFor: 'initialization' stamp: 'DiegoLont 9/20/2012 14:56'!
initializeKeywords
	| values |
	keywords := Dictionary new.
	values := #('absolute' 'abstract' 'add' 'array' 'asm' 'assembler' 'assembly' 'at' 'automated' 'begin' 'case' 'cdecl' 'class' 'const' 'constructor' 'default' 'deprecated' 'destructor' 'dispid' 'do' 'downto' 'dynamic' 'else' 'end' 'except' 'export' 'exports' 'external' 'final' 'finalization' 'finally' 'for' 'function' 'if' 'implementation' 'implements' 'in' 'index' 'inherited' 'inline' 'initialization' 'interface' 'label' 'library' 'message' 'name' 'nodefault' 'object' 'of' 'on' 'operator' 'out' 'overload' 'override' 'package' 'packed' 'pascal' 'pointer' 'private' 'procedure' 'program' 'property' 'protected' 'public' 'published' 'raise' 'read' 'readonly' 'record' 'reference' 'register' 'reintroduce' 'remove' 'repeat' 'resident' 'resourcestring' 'safecall' 'sealed' 'set' 'static' 'stdcall' 'strict' 'stored' 'then' 'threadvar' 'to' 'try' 'type' 'unit' 'until' 'uses' 'var' 'varargs' 'virtual' 'while' 'with' 'write' 'writeonly').
	
	values do: [:eachKeyword |
		keywords at: eachKeyword 
			put: (PPUnresolvedParser named: ('keyword', eachKeyword first asUppercase asString , eachKeyword allButFirst))		
		].
	
	keywords keysAndValuesDo:  [:key :value |
		(keywords at: key) def: (key asParser ,  #word asParser not)]! !

!PPDelphiLexicon methodsFor: 'initialization' stamp: 'DiegoLont 9/20/2012 15:34'!
initializeOperators

	| values |
	operators := Dictionary new.
	values := #( '^' '+' '-' '*' '/' 'xor' 'or' 'and' 'mod' 'div' 'shl' 'shr' 'as' 'not' '=' '<' '>' ':=' 'in' 'is' '<>' '<=' '>=' '@' '@@' 'e' 'file' 'string' ).
	
	values do: [:eachOperator |
		operators at: eachOperator 
			put: (PPUnresolvedParser named: ('operator', eachOperator asString))		
		].
	
	operators  keysAndValuesDo:  [:key :value |
		(operators at: key) def: (key asParser)]! !

!PPDelphiLexicon methodsFor: 'initialization' stamp: 'StephanEggermont 9/19/2012 14:41'!
initializeSeparators

	| values |
	separators := Dictionary new.
	values := #( '(' ')' '[' ']' ';' ',' '.' ':' '$' '..').
	
	values do: [:eachSeparator |
		separators at: eachSeparator 
			put: (PPUnresolvedParser named: ('separator', eachSeparator asString))		
		].
	
	separators  keysAndValuesDo:  [:key :value |
		(separators at: key) def: (key asParser)]! !

!PPDelphiLexicon methodsFor: 'grammar-input' stamp: 'DiegoLont 9/6/2012 11:05'!
input
	^ (inputElements optional) , (sub optional)! !

!PPDelphiLexicon methodsFor: 'grammar-input' stamp: 'DiegoLont 9/6/2012 11:06'!
inputElement
	^ whiteSpace / comment / delphiToken! !

!PPDelphiLexicon methodsFor: 'grammar-input' stamp: 'DiegoLont 9/6/2012 11:06'!
inputElements
	^ inputElement plus! !

!PPDelphiLexicon methodsFor: 'grammar-input' stamp: 'DiegoLont 9/6/2012 11:25'!
keyword
	| keywordParsers |
	keywordParsers := keywords keysSortedSafely 
								collect: [:eachKey | keywords at: eachKey ].
	^ self asToken: ( (keywordParsers reduce: [ :a :b | a / b ]) )! !

!PPDelphiLexicon methodsFor: 'grammar-input' stamp: 'DiegoLont 9/13/2012 14:15'!
quotedStringLiteral
	^$' asParser, stringCharacters optional, $' asParser! !

!PPDelphiLexicon methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 11:37'!
start
	^input end! !

!PPDelphiLexicon methodsFor: 'grammar-input' stamp: 'DiegoLont 9/13/2012 14:07'!
stringCharacter
	^ (('''''' asParser) ==> #second) / $' asParser negate! !

!PPDelphiLexicon methodsFor: 'grammar-input' stamp: 'DiegoLont 9/6/2012 13:08'!
stringCharacters
	^stringCharacter plus! !

!PPDelphiLexicon methodsFor: 'grammar-input' stamp: 'DiegoLont 9/13/2012 14:17'!
stringLiteral
	^(quotedStringLiteral, (controlStringLiteral, quotedStringLiteral) star, controlStringLiteral optional) | 
		(controlStringLiteral, (quotedStringLiteral, controlStringLiteral) star, quotedStringLiteral optional)! !

!PPDelphiLexicon methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 11:06'!
sub
	^ (Character value: 26) asParser ! !

!PPDelphiLexicon methodsFor: 'parsing' stamp: 'DiegoLont 9/6/2012 12:20'!
tokenFor: aString
	^self asToken: (keywords at: aString 
		ifAbsent: [separators at: aString 
			ifAbsent: [operators at: aString] ])! !

!PPDelphiLexicon methodsFor: 'grammar-whiteSpace' stamp: 'DiegoLont 9/6/2012 11:08'!
whiteSpace
	^#space asParser! !

PPDelphiLexicon subclass: #PPDelphiSyntax
	instanceVariableNames: 'program unit package identifier mainUses block unitInterface unitImplementation uses usesIn constantExpression identifierList asmStatement compilationUnit programDeclaration delphiLiterals parameterList library libraryDeclaration namespaceName statementPart statement statementList simpleStatement designator namespacedQualifiedIdent designatorItem expressionList compoundStatement qualifiedIdentifier expression colonConstruct simpleExpression term addOperation factor multiplierOperation designatorParameterList unitInitialization unitFinalization unitBlock usesClause interfaceDeclaration namespaceNameList typeDeclaration varDeclaration typeSection varSection customAttribute typeDecl hintingDirective customAttributeDecl genericDefinition varValueSpec genericTypeIdent simpleType strucType classDecl classTypeDecl classState classParent classItem classField visibility classMethod methodKey formalParameterSection methodDirective formalParameterList formalParameter parmType declSection procDecl procDeclHeading functionDirective blockBody assemblerStatement ifStatement relOp closureExpression caseStatement whileStatement forStatement withStatement tryStatement raiseStatement repeatStatement caseItem handlerList caseLabel handler labelDeclSection constSection methodDecl exportsSection assemblyAttribute constDeclaration constExpression methodDeclHeading exportItem exportedProcHeading pointerType stringType procedureType genericPostFix codePageNumber procedureTypeHeading subRangeType enumType classTypeTypeDecl bindingDirective externalDirective externalSpecifier classProperty classPropertyArray classPropertyIndex classPropertySpecifier classPropertyReadWrite classPropertyDispInterface typeId constrainedGeneric genericConstraint arrayType setType fileType number setSection methodIdentifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitDelphi-Core'!

PPDelphiSyntax subclass: #PPDelphiParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitDelphi-Core'!

!PPDelphiParser methodsFor: 'parsing' stamp: 'DiegoLont 9/13/2012 15:57'!
identifier
	^super identifier flatten! !

!PPDelphiParser methodsFor: 'parsing' stamp: 'DiegoLont 9/6/2012 15:54'!
mainUses
	^super mainUses ==> [ :tokens | 
		| retVal |
		retVal := OrderedCollection new.
		tokens second ifNotNil: [ retVal add: tokens second ].
		tokens size > 2 ifTrue: [ retVal addAll: (tokens third collect: [ :each | each second ]) ].
		retVal ]! !

!PPDelphiParser methodsFor: 'parsing' stamp: 'DiegoLont 9/13/2012 16:23'!
namespaceName
	^super namespaceName ==> [ :tokens | 
		tokens size < 3
			ifTrue: [ tokens first value trimBoth ]
			ifFalse: [ self halt ] ]! !

!PPDelphiParser methodsFor: 'parsing' stamp: 'DiegoLont 9/13/2012 10:47'!
program
	^super program ==> [ :tokens | PDProgramNode onTokens: tokens ]! !

!PPDelphiParser methodsFor: 'parsing' stamp: 'DiegoLont 9/6/2012 15:34'!
programDeclaration
	^super programDeclaration ==> [ :tokens | tokens second value ]! !

!PPDelphiParser methodsFor: 'parsing' stamp: 'DiegoLont 9/13/2012 15:58'!
stringLiteral
	^super stringLiteral flatten! !

!PPDelphiParser methodsFor: 'parsing' stamp: 'DiegoLont 9/13/2012 16:28'!
unit
	^super unit ==> [ :tokens | PDUnitNode onTokens: tokens ]! !

!PPDelphiParser methodsFor: 'parsing' stamp: 'DiegoLont 9/13/2012 16:02'!
usesIn
	^super usesIn ==> [ :tokens | 
		tokens second
			ifNil: [ PDUseClause on: tokens first value ]
			ifNotNil: [ PDUseClause on: tokens first filename: 
				(tokens second second trimBoth: [:char | char =$' ]) ] ]! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 14:23'!
addOperation
	^(self tokenFor: '+') | (self tokenFor: '-') | (self tokenFor: 'or') | (self tokenFor: 'xor')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 14:57'!
arrayType
	^(self tokenFor: 'array'), ((self tokenFor: '['), (self plusFor: ((constExpression , (self tokenFor: '..'), constExpression) / typeId) separatedByToken: ','), (self tokenFor: ']')) optional, (self tokenFor: 'of'), ((self tokenFor: 'const') / typeDecl)! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 09:35'!
asmStatement
	^'asmStatement' asParser! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 13:37'!
assemblerStatement
	^(self tokenFor: 'asm'), asmStatement, (self tokenFor: 'end')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 10:47'!
assemblyAttribute
	^(self tokenFor: '['), (self tokenFor: 'assembly'), customAttributeDecl, (self tokenFor: ']')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 13:25'!
bindingDirective
	^(self tokenFor: 'message'), expression, (self tokenFor: ';') / ((self tokensOneOf: #( 'static' 'dynamic' 'override' 'virtual' )), (self tokenFor: ';'))! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 13:39'!
block
	^declSection star, blockBody optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 13:36'!
blockBody
	^compoundStatement | assemblerStatement! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'StephanEggermont 9/19/2012 14:37'!
caseItem
	^caseLabel, ( (self tokenFor: ','), caseLabel) star, (self tokenFor: ':'), statement, (self tokenFor: ';') optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'StephanEggermont 9/19/2012 14:41'!
caseLabel
	^ expression, ((self tokenFor: '..'), expression) optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'StephanEggermont 9/18/2012 08:20'!
caseStatement
	^ (self tokenFor: 'case'), expression , (self tokenFor: 'of'), (caseItem star), ((self tokenFor: 'else'), statementList, ((self tokenFor:';') optional) optional ), (self tokenFor:'end')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 13:06'!
classDecl
	^classTypeTypeDecl / classTypeDecl! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 13:01'!
classField
	^customAttribute optional, identifierList, (self tokenFor: ':'), typeDecl, (self tokenFor: ';'), hintingDirective star! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 13:41'!
classItem
	^visibility / classMethod / classField / classProperty / typeSection / ((self tokenFor: 'class') optional, varSection)! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'StephanEggermont 9/23/2012 14:37'!
classMethod
	^methodKey, qualifiedIdentifier, genericDefinition optional, formalParameterSection optional, ((self tokenFor: ':'), customAttribute optional, typeDecl) optional, (self tokenFor: ';'), methodDirective star! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 14:22'!
classParent
	^(self tokenFor: '('), (self plusFor: typeId separatedByToken: ','), (self tokenFor: ')')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 14:37'!
classProperty
	^customAttribute optional, (self tokenFor: 'class') optional, (self tokenFor: 'property'), identifier, classPropertyArray optional, ((self tokenFor: ':'), identifier) optional, classPropertyIndex optional, classPropertyReadWrite star, (self tokenFor: ';'), classPropertySpecifier star! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 13:43'!
classPropertyArray
	^(self tokenFor: '['), formalParameterList, (self tokenFor: ']')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 13:54'!
classPropertyDispInterface
	^((self tokenFor: 'readonly') /
		(self tokenFor: 'writeonly') /
		((self tokenFor: 'dispid'), expression)),
	(self tokenFor: ';')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 13:44'!
classPropertyIndex
	^(self tokenFor: 'index'), expression, (self tokenFor: ';')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 13:52'!
classPropertyReadWrite
	^(self tokensOneOf: #( 'read' 'write' 'add' 'remove')), qualifiedIdentifier! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 14:37'!
classPropertySpecifier
	^ classPropertyDispInterface /
		(((self tokensOneOf: #('stored' 'default')), expression, (self tokenFor: ';'))) /
		((self tokenFor: 'nodefault'), (self tokenFor: ';')) /
		((self tokenFor: 'implements'), identifier, (self tokenFor: ';'))! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 11:32'!
classState
	^(self tokenFor: 'sealed') | (self tokenFor: 'abstract')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 13:13'!
classTypeDecl
	^(self tokenFor: 'class'), 
		((classState optional, classParent optional, classItem star, (self tokenFor: 'end')) / (classParent optional))! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 13:06'!
classTypeTypeDecl
	^(self tokenFor: 'class'), (self tokenFor: 'of'), identifier! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 14:38'!
closureExpression
	^((self tokenFor: 'procedure'), formalParameterSection optional, block) /
		((self tokenFor: 'function'), formalParameterSection optional, (self tokenFor: ':'), typeDecl, block)! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 12:47'!
codePageNumber
	^(self tokenFor: '('), constExpression, (self tokenFor: ')')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 14:26'!
colonConstruct
	^'colonConstruct' asParser! !

!PPDelphiSyntax methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2012 16:21'!
compilationUnit
	^(program / unit / library / package)! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 14:10'!
compoundStatement
	^(self tokenFor: 'begin'), statementList, (self tokenFor: 'end')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 11:20'!
constDeclaration
	^customAttribute optional, identifier, ((self tokenFor: ':'), typeDecl) optional, (self tokenFor: '='), constExpression, hintingDirective star, (self tokenFor: ';')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 10:33'!
constExpression
	^expression! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 10:31'!
constSection
	^((self tokenFor: 'const') | (self tokenFor: 'resourcestring')), constDeclaration plus! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 09:16'!
constantExpression
	" this is more complicated, but will do for now "
	^#word asParser! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 14:46'!
constrainedGeneric
	^identifier, ((self tokenFor: ':'), (self plusFor: genericConstraint separatedByToken: ',')) optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 11:08'!
customAttribute
	^(self tokenFor: '['), customAttributeDecl, (self tokenFor: ']')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 11:09'!
customAttributeDecl
	^namespacedQualifiedIdent, (self tokenFor: '('), expressionList, (self tokenFor: ')')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 10:56'!
declSection
	^labelDeclSection / constSection / typeSection / varSection / methodDecl / procDecl / exportsSection / assemblyAttribute! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 11:53'!
delphiLiterals
	^(#letter asParser / '_' asParser), ((#word asParser / '_' asParser) star)! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 13:16'!
designator
	^(self tokenFor: 'inherited') optional, namespacedQualifiedIdent optional, designatorItem star! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 15:23'!
designatorItem
	^(self tokenFor: '^') / ((self tokenFor: '.'), identifier) / ((self tokenFor: '['), expressionList, (self tokenFor: ']')) / designatorParameterList! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 14:29'!
designatorParameterList
	^(self tokenFor: '('), (expression, colonConstruct optional, ((self tokenFor: ','), expression, colonConstruct optional) star) optional, (self tokenFor: ')')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 13:01'!
enumType
	^(self tokenFor: '('), (self plusFor: (identifier, ((self tokenFor: '='), expression) optional) separatedByToken: ','), (self tokenFor: ')')
	! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 10:50'!
exportItem
	^((self tokenFor: '('), formalParameterList optional, (self tokenFor: ')')) optional, ((self tokenFor: 'index') , 
expression) optional, ((self tokenFor: 'name'), expression) optional, (self tokenFor: 'resident') optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 12:38'!
exportedProcHeading
	^((self tokenFor: 'procedure'), identifier, formalParameterSection optional, (self tokenFor: ';'), functionDirective star) | ((self tokenFor: 'function'), identifier, formalParameterSection optional, (self tokenFor: ':'), customAttribute optional, typeDecl, (self tokenFor: ';'), functionDirective star)! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 10:39'!
exportsSection
	^(self tokenFor: 'exports'), identifier, exportItem, ((self tokenFor: ','), identifier, exportItem) star, (self tokenFor: ';')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 14:33'!
expression
	^(simpleExpression, (relOp, simpleExpression) optional) / closureExpression! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 15:26'!
expressionList
	^self plusFor: expression separatedByToken: ','! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 13:32'!
externalDirective
	^((self tokenFor: 'external'), constExpression, externalSpecifier star, (self tokenFor: ';')) /
	((self tokensOneOf: #( 'varargs' 'external' )), (self tokenFor: ';'))! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 13:32'!
externalSpecifier
	^(self tokensOneOf: #( 'name' 'index' )), constExpression! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 15:33'!
factor
	^((self tokensOneOf: #( '@' '@@' 'not' '+' '-')), factor) / ((self tokenFor: '^'), identifier) / number / ((self tokenFor: '('), expression, (self tokenFor: ')')) / stringLiteral / setSection / designator! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 14:57'!
fileType
	^(self tokenFor: 'file'), ((self tokenFor: 'of'), typeDecl) optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'StephanEggermont 9/23/2012 15:30'!
forStatement
	^ ((self tokenFor: 'for'), designator, (self tokenFor: ':='), expression, (self tokensOneOf: #( 'to' 'downto' 'in') ), expression, (self tokenFor: 'do'), statement ) ! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 12:37'!
formalParameter
	^customAttribute optional, parmType optional, identifierList, ((self tokenFor: ':'), typeDecl) optional, ((self tokenFor: '='), expression) optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 14:24'!
formalParameterList
	^self plusFor: formalParameter separatedByToken: ';'! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 12:31'!
formalParameterSection
	^(self tokenFor: '('), formalParameterList, (self tokenFor: ')')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 13:28'!
functionDirective
	^(self tokenFor: 'overload'), (self tokenFor: ';')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 14:47'!
genericConstraint
	^(self tokensOneOf: #( 'record' 'class' 'constructor')) / identifier! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 14:45'!
genericDefinition
	^(self tokenFor: '<'), (self plusFor: constrainedGeneric separatedByToken: ','), (self tokenFor: '>')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 12:59'!
genericPostFix
	^(self tokenFor: '<'), (self plusFor: typeDecl separatedByToken: ','), (self tokenFor: '>')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 11:10'!
genericTypeIdent
	^identifier, genericDefinition optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'StephanEggermont 9/23/2012 15:43'!
handler
	(self tokenFor: 'on'), identifier, (self tokenFor: ':'), namespacedQualifiedIdent , (self tokenFor: 'do'), statement , (self tokenFor: ';')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'StephanEggermont 9/19/2012 14:39'!
handlerList
	^((handler star), ( (self tokenFor: 'else'), statementList) optional) /
	statementList! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 11:07'!
hintingDirective
	^self tokenFor: 'deprecated'! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 12:31'!
identifier
	^self asToken: ((keyword not), delphiLiterals)! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 11:05'!
identifierList
	^self plusFor: identifier separatedByToken: ','! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 14:30'!
ifStatement
	^(self tokenFor: 'if'), expression, (self tokenFor: 'then'), statement, ((self tokenFor: 'else'), statement) optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 14:40'!
intNumber
	^(#digit asParser plus) / ((self tokenFor: '$'), (#hex asParser plus))! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 12:34'!
interfaceDeclaration
	^constSection / typeSection / varSection / exportedProcHeading / exportsSection / assemblyAttribute! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 10:29'!
labelDeclSection
	^(self tokenFor: 'label'), $; asParser negate, (self tokenFor: ';')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 12:50'!
library
	^libraryDeclaration, mainUses optional, block, '.' asParser! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 12:43'!
libraryDeclaration
	^(self tokenFor: 'library'), identifier, (self tokenFor: ';')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 15:43'!
mainUses
	^(self tokenFor: 'uses'), usesIn, ((self tokenFor: ','), usesIn) star, (self tokenFor: ';')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 11:08'!
methodDecl
	^methodDeclHeading, (self tokenFor: ';'), methodDirective star, (block, (self tokenFor: ';')) optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 16:12'!
methodDeclHeading
	^customAttribute optional, methodKey, methodIdentifier, formalParameterSection optional, ((self tokenFor: ':'), customAttribute optional, typeDecl) optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 13:25'!
methodDirective
	^((self tokensOneOf: #( 'reintroduce' 'overload' 'abstract' 'final' 'inline' 'assembler' 'cdecl' 'pascal' 'register' 'safecall' 'stdcall' 'export')), (self tokenFor: ';')) / bindingDirective / (hintingDirective, (self tokenFor: ';')) / externalDirective! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 16:13'!
methodIdentifier
	^(qualifiedIdentifier, genericDefinition optional, (self tokenFor: '.')) optional, qualifiedIdentifier! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'StephanEggermont 9/23/2012 14:34'!
methodKey
	^
	(self tokenFor: 'constructor') /
		(self tokenFor: 'destructor') /
		((self tokenFor: 'class') optional, ((self tokenFor:'procedure'))) /
	 		(self tokenFor: 'operator') /
			(self tokenFor: 'function')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 14:24'!
multiplierOperation
	^(self tokenFor: '*') | (self tokenFor: '/') | (self tokenFor: 'div') | (self tokenFor: 'mod') |  (self tokenFor: 'and') | (self tokenFor: 'shl') | (self tokenFor: 'shr') | (self tokenFor: 'as')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 12:57'!
namespaceName
	^identifier, ((self tokenFor: '.'), identifier) star! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 11:02'!
namespaceNameList
	^namespaceName, ((self tokenFor: ','), namespaceName) star, (self tokenFor: ';')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 14:16'!
namespacedQualifiedIdent
	^(namespaceName, (self tokenFor: '.')) optional, qualifiedIdentifier! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 15:13'!
number
	^#digit asParser plus, ((self tokenFor: '.'), #digit asParser plus) optional, ((self tokenFor: 'e'), (self tokensOneOf: #('+' '-')) optional, #digit asParser plus) optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 09:24'!
package
	^'package' asParser, #any asParser star! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 12:40'!
parameterList
	^(self tokenFor: '('), identifierList optional, (self tokenFor: ')')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 12:35'!
parmType
	^(self tokenFor: 'const') | (self tokenFor: 'var') | (self tokenFor: 'out')! !

!PPDelphiSyntax methodsFor: 'convenience' stamp: 'DiegoLont 9/20/2012 11:01'!
plusFor: aParser separatedBy: aSeparatorParser
	^aParser, (aSeparatorParser, aParser) star! !

!PPDelphiSyntax methodsFor: 'convenience' stamp: 'DiegoLont 9/20/2012 11:04'!
plusFor: aParser separatedByToken: aToken
	^self plusFor: aParser separatedBy: (self tokenFor: aToken)! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 12:45'!
pointerType
	^((self tokenFor: '^'), typeDecl) | (self tokenFor: 'pointer')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 11:51'!
procDecl
	^procDeclHeading, (self tokenFor: ';'), functionDirective star, (block, (self tokenFor: ';')) optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 13:43'!
procDeclHeading
	^customAttribute optional, (((self tokenFor: 'procedure'), namespacedQualifiedIdent, formalParameterSection optional)
		|((self tokenFor: 'function'), namespacedQualifiedIdent, formalParameterSection optional, (self tokenFor: ':'), typeDecl))! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 13:03'!
procedureType
	^(procedureTypeHeading, (self tokenFor: 'of'), (self tokenFor: 'object')) / ((self tokenFor: 'reference'), (self tokenFor: 'to'), procedureTypeHeading) / procedureTypeHeading! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 12:51'!
procedureTypeHeading
	^((self tokenFor: 'function'), formalParameterSection optional, (self tokenFor: ':'), customAttribute optional, typeDecl) / ((self tokenFor: 'procedure'), formalParameterSection optional)! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 14:32'!
program
	^programDeclaration optional, mainUses optional, block, (self tokenFor: '.')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 12:43'!
programDeclaration
	^(self tokenFor: 'program'), identifier, parameterList optional, (self tokenFor: ';')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 11:09'!
qualifiedIdentifier
	^self plusFor: identifier separatedByToken: '.'! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'StephanEggermont 9/19/2012 14:31'!
raiseStatement
	^ (self tokenFor: 'raise'), (designator optional), (( (self tokenFor: 'at'), designator) optional) ! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 15:11'!
realNumber
	^#digit asParser plus, ((self tokenFor: '.'), #digit asParser plus) optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 11:34'!
relOp
	^(self tokenFor: '<=') / (self tokenFor: '>=') /  (self tokenFor: '<>') / (self tokenFor: '=') / (self tokenFor: 'in') / (self tokenFor: 'is') / (self tokenFor: '<') / (self tokenFor: '>')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'StephanEggermont 9/19/2012 14:34'!
repeatStatement
	^(self tokenFor: 'repeat'), statementList, (self tokenFor: 'until'), expression! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 15:19'!
setSection
	^(self tokenFor: '['), (self plusFor: expression separatedBy: (self tokensOneOf: #( ',' '..'))) optional, (self tokenFor: ']') ! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 14:56'!
setType
	^(self tokenFor: 'set'), (self tokenFor: 'of'), typeDecl! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 14:22'!
simpleExpression
	^term, (addOperation, term) star! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 15:21'!
simpleStatement
	^designator, ((self tokenFor: ':='), expression) optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 12:53'!
simpleType
	^identifier / subRangeType / enumType! !

!PPDelphiSyntax methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 10:59'!
start
	^compilationUnit end! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 13:59'!
statement
	^(label, (self tokenFor: ':')) optional, statementPart! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 14:00'!
statementList
	^statement optional, ((self tokenFor: ';'), statement) star! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'StephanEggermont 9/18/2012 08:12'!
statementPart
	^ifStatement / caseStatement / repeatStatement / whileStatement / forStatement / withStatement / tryStatement / raiseStatement / assemblerStatement / compoundStatement / simpleStatement! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 12:47'!
stringType
	^((self tokenFor: 'string'), ((self tokenFor: '['), expression, (self tokenFor: ']')) optional) / (identifier, codePageNumber optional)! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 14:52'!
strucType
	^(self tokenFor: 'packed') optional, (arrayType / setType / fileType / classDecl)! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 12:54'!
subRangeType
	^constExpression, ((self tokenFor: '..'), constExpression)! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 14:22'!
term
	^factor, (multiplierOperation, factor) star! !

!PPDelphiSyntax methodsFor: 'convenience' stamp: 'DiegoLont 9/20/2012 13:25'!
tokensOneOf: anArray
	| retVal |
	retVal := nil.
	anArray do: [ :each |
		retVal ifNil: [ retVal := self tokenFor: each ]
			ifNotNil: [ retVal := retVal | (self tokenFor: each) ] ].
	^retVal! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'StephanEggermont 9/19/2012 14:28'!
tryStatement
	^ ((self tokenFor: 'try'), statementList , (self tokenFor: 'except'), handlerList, (self tokenFor: 'end')) /
	((self tokenFor: 'try'), statementList , (self tokenFor: 'finally'), statementList , (self tokenFor: 'end'))! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 14:31'!
typeDecl
	^((self tokenFor: 'type') optional, typeId) / strucType / pointerType / stringType / procedureType / simpleType! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 11:19'!
typeDeclaration
	^customAttribute optional, genericTypeIdent, (self tokenFor: '='), typeDecl, hintingDirective star, (self tokenFor: ';')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 14:23'!
typeId
	^namespacedQualifiedIdent, ((self tokenFor: '<'), (self plusFor: typeId separatedByToken: ','), (self tokenFor: '>')) optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 11:05'!
typeSection
	^(self tokenFor: 'type'), typeDeclaration plus! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 10:55'!
unit
	^(self tokenFor: 'unit'), identifier, (self tokenFor: ';'), uses star, unitInterface, unitImplementation, unitBlock, (self tokenFor: '.')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 13:19'!
unitBlock
	^(unitInitialization, (self tokenFor: 'end')) / compoundStatement / (self tokenFor: 'end')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 15:10'!
unitFinalization
	^(self tokenFor: 'finalization'), statementList! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 13:23'!
unitImplementation
	^(self tokenFor: 'implementation'), usesClause optional, declSection star! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 15:09'!
unitInitialization
	^(self tokenFor: 'initialization'), statementList, unitFinalization optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/20/2012 12:33'!
unitInterface
	^(self tokenFor: 'interface'), usesClause optional, interfaceDeclaration star! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 09:22'!
uses
	^'uses' asParser, identifierList, ';' asParser! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 11:00'!
usesClause
	^(self tokenFor: 'uses'), namespaceNameList! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/6/2012 13:14'!
usesIn
	^namespaceName, ((self tokenFor: 'in'), stringLiteral) optional! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 11:16'!
varDeclaration
	^customAttribute optional, identifierList, (self tokenFor: ':'), typeDecl, varValueSpec optional, hintingDirective star, (self tokenFor: ';')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 11:15'!
varSection
	^((self tokenFor: 'var') | (self tokenFor: 'threadvar')), varDeclaration plus! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 11:16'!
varValueSpec
	^(self tokenFor: 'absolute'), identifier! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'DiegoLont 9/13/2012 11:41'!
visibility
	^((self tokenFor: 'strict') optional, (self tokenFor: 'protected')) |
		((self tokenFor: 'strict') optional, (self tokenFor: 'private')) |
		(self tokenFor: 'public') |
		(self tokenFor: 'published') |
		(self tokenFor: 'automated')! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'StephanEggermont 9/18/2012 08:27'!
whileStatement
	^ (self tokenFor: 'while'), expression, (self tokenFor:'do'), statement! !

!PPDelphiSyntax methodsFor: 'rules' stamp: 'StephanEggermont 9/18/2012 08:32'!
withStatement
	^ (self tokenFor: 'with' ), designator,( ((self tokenFor: ','), designator) star), (self tokenFor: 'do'), statement! !

!PPParser methodsFor: '*petitdelphi-operations' stamp: 'DiegoLont 9/6/2012 11:34'!
delphiToken
	^ PPDelphiTokenParser on: self! !

PPToken subclass: #PPDelphiToken
	instanceVariableNames: 'comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitDelphi-Core'!

!PPDelphiToken methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 10:41'!
comments
	^ comments! !

!PPDelphiToken methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 10:41'!
comments: anObject
	comments := anObject! !

PPTokenParser subclass: #PPDelphiTokenParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitDelphi-Core'!

!PPDelphiTokenParser methodsFor: 'defaults' stamp: 'DiegoLont 9/6/2012 10:42'!
defaultTokenClass
	^ PPDelphiToken! !

!PPDelphiTokenParser methodsFor: 'parsing' stamp: 'DiegoLont 9/20/2012 11:27'!
parseComments: anArray on: aStream
	
	| start comments |
	comments := anArray.
	[ 
		| peekTwice |
		[ aStream atEnd not and: [ aStream peek isSeparator ] ]
			whileTrue: [ aStream next ].
	peekTwice := aStream peekTwice.
	((peekTwice first = ${) or: [	
	  (peekTwice  first = $/) and: 
		[ (peekTwice second = $*) or: [ peekTwice second = $/ ] ]])] whileTrue: [
		| commentChar |
		commentChar := aStream next.
		Transcript show: ('position ', aStream position asString, ' char ', commentChar asString); cr.
		start := aStream position.
		(commentChar = ${)
			ifTrue: [ aStream upToAll: '}' ]
			ifFalse: [
				(aStream next = $*)
					ifTrue: [ aStream upToAll: '*/' ]
					ifFalse: [ aStream upToAnyOf: CharacterSet crlf ] ].
		comments := comments copyWith: (start to: aStream position) ].
	^ comments! !

!PPDelphiTokenParser methodsFor: 'parsing' stamp: 'DiegoLont 9/6/2012 10:52'!
parseOn: aStream
	| token comments start element stop |
	start := aStream position.
	comments := self
		parseComments: #()
		on: aStream.
	token := super parseOn: aStream.
	token isPetitFailure ifTrue: [
		aStream position: start.
		^ token ].
	comments := self
		parseComments: comments
		on: aStream.
	^ token comments: comments! !

PPCompositeParserTest subclass: #PPDelphiTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitDelphi-Tests'!

PPDelphiTest subclass: #PPDelphiLexiconTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitDelphi-Tests'!

!PPDelphiLexiconTest methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 10:55'!
parserClass
	^PPDelphiLexicon! !

!PPDelphiLexiconTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 11:43'!
testComment
	self parse: '{ this is a traditional pascal comment }' rule: #comment! !

!PPDelphiLexiconTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 11:15'!
testComment2
	self parse: '/* This is a c-style comment */' rule: #comment! !

!PPDelphiLexiconTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 11:17'!
testCommentFail
	self fail: '{ this is a traditional pascal comment } with an extra close }' rule: #comment! !

!PPDelphiLexiconTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 11:38'!
testCommentFail2
	self fail: '/* This is a c-style comment */ with two closes */' rule: #comment! !

!PPDelphiLexiconTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 11:17'!
testCommentFailNested
	self parse: '{ { { /* this is a valid comment */ }' rule: #comment! !

!PPDelphiLexiconTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 14:07'!
testStringLiteral
	self parse: '''This is a string''' rule: #stringLiteral! !

!PPDelphiLexiconTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 14:07'!
testStringLiteral2
	self parse: '''This is a string '''' with a carriage return \n and a
	 nested quote''' rule: #stringLiteral! !

!PPDelphiLexiconTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 14:19'!
testStringLiteral3
	self parse: '#123' rule: #stringLiteral! !

!PPDelphiLexiconTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 14:19'!
testStringLiteral4
	self parse: '#123''Bladiebla''#$ab12' rule: #stringLiteral! !

!PPDelphiLexiconTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 14:21'!
testStringLiteral5
	self parse: '#123#$ab12' rule: #stringLiteral! !

!PPDelphiLexiconTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 14:21'!
testStringLiteralFail
	self fail: '''123'' ''#$ab12''' rule: #stringLiteral! !

PPDelphiTest subclass: #PPDelphiParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitDelphi-Tests'!

!PPDelphiParserTest methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 12:58'!
parserClass
	^PPDelphiParser! !

!PPDelphiParserTest methodsFor: 'accessing' stamp: 'DiegoLont 9/20/2012 12:58'!
testProgramName
	self assert: (self parse: self program1 rule: #program) programName equals: 'testProgram'! !

!PPDelphiParserTest methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 15:47'!
testProgramUnits
	self assert: (self parse: self program1 rule: #program) unitNames equals: #()! !

!PPDelphiParserTest methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 15:57'!
testProgramUnits1
	| unitNames |
	unitNames := (self parse: self program2 rule: #program) unitNames.
	self assert: 2 equals: unitNames size.
	self assert: (unitNames includes: 'Forms').
	self assert: (unitNames includes: 'Unit1')! !

PPDelphiTest subclass: #PPDelphiSyntaxTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitDelphi-Tests'!

!PPDelphiSyntaxTest methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 12:58'!
parserClass
	^PPDelphiSyntax! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 13:54'!
testBlock
	(self parse: 'begin
end' rule: #block)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 13:54'!
testBlock1
	(self parse: 'begin
	Application.Initialize;
	Application.CreateForm(TForm1, Form1);
	Application.Run;
end' rule: #block)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:55'!
testBlock2
	(self parse: 'var
  email: IChilkatEmail2;
  ok: Integer;

begin
  ChilkatMailMan21.UnlockComponent(''Anything for 30-day trial'');
  ChilkatMailMan21.SmtpHost := ''smtp.comcast.net'';

  email := ChilkatMailMan21.NewEmail();
  email.Subject := ''This is a test'';
  email.From := ''Chilkat Support <support@chilkatsoft.com>'';
  email.AddTo(''John Doe'',''jdoe@someplace.com'');
  email.Body := ''This is the body...'';

  ok := ChilkatMailMan21.SendEmail(email);
  if (ok = 0) then
        ChilkatMailMan21.SaveLastError(''errorLog.xml'');
  
end' rule: #block)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:57'!
testBlockBody
	(self parse: 'begin
  ChilkatMailMan21.UnlockComponent(''Anything for 30-day trial'');
  ChilkatMailMan21.SmtpHost := ''smtp.comcast.net'';

  email := ChilkatMailMan21.NewEmail();
  email.Subject := ''This is a test'';
  email.From := ''Chilkat Support <support@chilkatsoft.com>'';
  email.AddTo(''John Doe'',''jdoe@someplace.com'');
  email.Body := ''This is the body...'';

  ok := ChilkatMailMan21.SendEmail(email);
  if (ok = 0) then
        ChilkatMailMan21.SaveLastError(''errorLog.xml'');
  
end' rule: #blockBody)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 15:06'!
testBlockFail
	(self fail: 'beginend' rule: #block)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 15:05'!
testBlockFail1
	(self fail: 'begin
	Application.Initialize;
	Application.CreateForm(TForm1, Form1);
	Application.Run;
end.' rule: #block)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:11'!
testClassDecl
	self parse: 'class(TForm)
    ChilkatMailMan21: TChilkatMailMan2;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end' rule: #classDecl! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:03'!
testClassItem
	self parse: 'ChilkatMailMan21: TChilkatMailMan2;' rule: #classItem! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:03'!
testClassItem1
	self parse: 'procedure Button1Click(Sender: TObject);' rule: #classItem! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:08'!
testClassItem2
	self parse: 'private' rule: #classItem! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:17'!
testClassMethod
	self parse: 'procedure Button1Click(Sender: TObject);' rule: #classMethod! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 12:41'!
testClassParent
	self parse: '(TForm)' rule: #classParent! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/20/2012 13:09'!
testClassTypeDecl
	self parse: 'class
  private
    FGUID: string;
    FData: Pointer;
    FAutoObject: PAutoObject;
  public
    constructor Create; virtual;
    destructor Destroy; override;
    procedure Store(Writer: PObjectWriter); virtual;
    procedure Load(Reader: PObjectReader); virtual;
    function GetAutomationObject: PAutoObject; virtual;
    property GUID: string read FGUID write FGUID;
    property Data: Pointer read FData write FData;
  end' rule: #classTypeDecl! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/20/2012 14:51'!
testClassTypeDecl1
	self parse: 'class
    Values: array of string;
    Objects: array of T;
  end' rule: #classTypeDecl! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/20/2012 14:19'!
testClassTypeDecl2
	self parse: 'class (TEnumerable<PObject>)
  private
    FList: TList;
    function GetItem(Index: Integer): PObject;
    procedure SetItem(Index: Integer; Value: PObject);
    function GetCount: Integer;
  protected
    function DoGetEnumerator: TEnumerator<PObject>; override;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Assign(OrderedSet: POrderedSet);
    procedure Add(Obj: PObject);
    procedure Remove(Obj: PObject);
    procedure Delete(Index: Integer);
    procedure Insert(Index: Integer; Obj: PObject);
    procedure Clear;
    procedure Sort(Compare: TListSortCompare);
    procedure Move(CurIndex, NewIndex: Integer);
    procedure Union(ASet: POrderedSet);
    procedure Subtract(ASet: POrderedSet);
    function IndexOf(Obj: PObject): Integer;
    function Contains(Obj: PObject): Boolean;
    function IsEmpty: Boolean;
    function FindByGuid(AGuid: string): PObject;
    property Items[Index: Integer]: PObject read GetItem write SetItem; default;
    property Count: Integer read GetCount;

  type
    TEnumerator = class(TEnumerator<PObject>)
    private
      FOrderedSet: POrderedSet;
      FIndex: Integer;
      function GetCurrent: PObject;
    protected
      function DoGetCurrent: PObject; override;
      function DoMoveNext: Boolean; override;
    public
      constructor Create(AOrderedSet: POrderedSet);
      property Current: PObject read GetCurrent;
      function MoveNext: Boolean;
    end; // End of TEnumerator

    end' rule: #classTypeDecl! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 14:11'!
testCompoundStatement
	(self parse: 'begin
	Application.Initialize
end' rule: #compoundStatement)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 14:11'!
testCompoundStatement1
	(self parse: 'begin
	Application.Initialize;
	Application.CreateForm(TForm1, Form1);
	Application.Run;
end' rule: #compoundStatement)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/20/2012 15:08'!
testConstExpression
	self parse: '0.0' rule: #constExpression! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:56'!
testDeclarationSection
	(self parse: 'var
  email: IChilkatEmail2;
  ok: Integer;' rule: #declSection)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 12:23'!
testDelphiName
	(self parse: 'program testProgram;' rule: #programDeclaration)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 14:14'!
testDesignator
	(self parse: 'Application.Initialize' rule: #designator)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 14:09'!
testDesignatorItem
	(self parse: '(''Anything for 30-day trial'')' rule: #designatorItem)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 14:30'!
testExpression
	(self parse: '(ok = 0)' rule: #expression)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 14:38'!
testExpression1
	(self parse: 'ok = 0' rule: #expression)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 14:39'!
testExpression2
	(self parse: '0' rule: #expression)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:44'!
testFormalParameter
	self parse: 'Sender: TObject' rule: #formalParameter! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:46'!
testFormalParameterSection
	self parse: '(Sender: TObject)' rule: #formalParameterSection! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'StephanEggermont 9/23/2012 14:50'!
testHandler
	self parse: 'on
    E: Exception do ;' rule: #handler! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'StephanEggermont 9/23/2012 14:50'!
testHandlerList
	self parse: 'on
    E: Exception do MessageDlg(E.Message, mtError, [mbOK], 0);' rule: #handlerList! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/20/2012 11:29'!
testIfStatement
	self parse: '	if (ComServer.StartMode <> smStandalone) then
  begin
    MainForm.Visible := False;
    Application.ShowMainForm := False;
  end' rule: #ifStatement! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 14:00'!
testInstructionList
	self parse: '' rule: #statementList! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 14:23'!
testMainUses
	(self parse: 'uses
	Forms,
	Unit1 in ''Unit1.pas'' {Form1};' rule: #mainUses)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 14:23'!
testMainUses1
	(self parse: 'uses
	Forms,
	Unit1 in ''Unit1.pas'' {Form1};
	{$R *.RES}' rule: #mainUses)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 14:36'!
testMainUsesFail
	(self fail: 'uses
	Forms,
	Unit1 in "Unit1.pas" {Form1};
	{$R *.RES}
	begin' rule: #mainUses)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'StephanEggermont 9/23/2012 14:43'!
testMethodDecl1
	self parse: 'procedure PMain.ApplicationDeactivateHandler(Sender: TObject);
begin
  try
//    EventPublisher.NotifyEvent(EK_APPLICATION_DEACTIVATE);
  except on
    E: Exception do MessageDlg(E.Message, mtError, [mbOK], 0);
  end;
end;' rule: #methodDecl! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'StephanEggermont 9/23/2012 14:43'!
testMethodDeclHeading
	self parse: 'procedure PMain.ApplicationDeactivateHandler(Sender: TObject)' rule: #methodDeclHeading! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:49'!
testNamespacedQualifiedIdent
	self parse: 'Form1.Button1Click' rule: #namespacedQualifiedIdent! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 14:53'!
testProcDecl
	self parse: 'procedure TForm1.Button1Click(Sender: TObject);
var
  email: IChilkatEmail2;
  ok: Integer;

begin
  ChilkatMailMan21.UnlockComponent(''Anything for 30-day trial'');
  ChilkatMailMan21.SmtpHost := ''smtp.comcast.net'';

  email := ChilkatMailMan21.NewEmail();
  email.Subject := ''This is a test'';
  email.From := ''Chilkat Support <support@chilkatsoft.com>'';
  email.AddTo(''John Doe'',''jdoe@someplace.com'');
  email.Body := ''This is the body...'';

  ok := ChilkatMailMan21.SendEmail(email);
  if (ok = 0) then
        ChilkatMailMan21.SaveLastError(''errorLog.xml'');
  
end;' rule: #procDecl! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:48'!
testProcDeclHeading
	self parse: 'procedure Button1Click(Sender: TObject)' rule: #procDeclHeading! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:48'!
testProcDeclHeading1
	self parse: 'procedure TForm1.Button1Click(Sender: TObject)' rule: #procDeclHeading! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 11:48'!
testProgram1
	self parse: self program1 rule: #program! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 11:48'!
testProgram2
	self parse: self program2 rule: #program! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 14:39'!
testProgram3
	self parse: self program3 rule: #program! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/20/2012 11:18'!
testProgram4
	self parse: self program4 rule: #program! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 14:14'!
testSimpleStatement
	(self parse: 'Application.Initialize' rule: #simpleStatement)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 08:50'!
testSource! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 14:13'!
testStatement
	(self parse: 'Application.Initialize' rule: #statement)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 14:17'!
testStatement1
	(self parse: 'Application.CreateForm(TForm1, Form1)' rule: #statement)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:59'!
testStatement2
	(self parse: 'ChilkatMailMan21.UnlockComponent(''Anything for 30-day trial'')' rule: #statement)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 14:24'!
testStatement3
	(self parse: 'ChilkatMailMan21.SmtpHost := ''smtp.comcast.net''' rule: #statement)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 14:27'!
testStatement4
	(self parse: 'if (ok = 0) then
        ChilkatMailMan21.SaveLastError(''errorLog.xml'')' rule: #statement)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 14:12'!
testStatementList
	(self parse: 'Application.Initialize' rule: #statementList)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 14:12'!
testStatementList1
	(self parse: 'Application.Initialize;
	Application.CreateForm(TForm1, Form1);
	Application.Run;' rule: #statementList)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:58'!
testStatementList2
	(self parse: 'ChilkatMailMan21.UnlockComponent(''Anything for 30-day trial'');
  ChilkatMailMan21.SmtpHost := ''smtp.comcast.net'';

  email := ChilkatMailMan21.NewEmail();
  email.Subject := ''This is a test'';
  email.From := ''Chilkat Support <support@chilkatsoft.com>'';
  email.AddTo(''John Doe'',''jdoe@someplace.com'');
  email.Body := ''This is the body...'';

  ok := ChilkatMailMan21.SendEmail(email);
  if (ok = 0) then
        ChilkatMailMan21.SaveLastError(''errorLog.xml'');' rule: #statementList)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 14:13'!
testStatementPart
	(self parse: 'Application.Initialize' rule: #statementPart)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 14:00'!
testStatementPart1
	(self parse: 'ChilkatMailMan21.UnlockComponent(''Anything for 30-day trial'')' rule: #statementPart)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:15'!
testStrucType
	self parse: 'class(TForm)
    ChilkatMailMan21: TChilkatMailMan2;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end' rule: #strucType! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:15'!
testTypeDecl
	self parse: 'class(TForm)
    ChilkatMailMan21: TChilkatMailMan2;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end' rule: #typeDecl! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/20/2012 13:04'!
testTypeDeclaration
	self parse: 'PCommandEvent = procedure(Sender: TObject; Command: PCommand) of object;' rule: #typeDeclaration! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/20/2012 13:04'!
testTypeDeclaration1
	self parse: 'TForm1 = class(TForm)
    ChilkatMailMan21: TChilkatMailMan2;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;' rule: #typeDeclaration! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/20/2012 13:04'!
testTypeDeclaration2
	self parse: 'PClass = class of PObject;' rule: #typeDeclaration! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 11:26'!
testTypeSection
	self parse: 'type
  TForm1 = class(TForm)
    ChilkatMailMan21: TChilkatMailMan2;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;' rule: #typeSection! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 10:52'!
testUnit
	self parse: self unit1 rule: #unit! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:20'!
testUnitImplementation
	self parse: 'implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  email: IChilkatEmail2;
  ok: Integer;

begin
  ChilkatMailMan21.UnlockComponent(''Anything for 30-day trial'');
  ChilkatMailMan21.SmtpHost := ''smtp.comcast.net'';

  email := ChilkatMailMan21.NewEmail();
  email.Subject := ''This is a test'';
  email.From := ''Chilkat Support <support@chilkatsoft.com>'';
  email.AddTo(''John Doe'',''jdoe@someplace.com'');
  email.Body := ''This is the body...'';

  ok := ChilkatMailMan21.SendEmail(email);
  if (ok = 0) then
        ChilkatMailMan21.SaveLastError(''errorLog.xml'');
  
end;' rule: #unitImplementation! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 13:21'!
testUnitImplementationFail
	self fail: 'implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  email: IChilkatEmail2;
  ok: Integer;

begin
  ChilkatMailMan21.UnlockComponent(''Anything for 30-day trial'');
  ChilkatMailMan21.SmtpHost := ''smtp.comcast.net'';

  email := ChilkatMailMan21.NewEmail();
  email.Subject := ''This is a test'';
  email.From := ''Chilkat Support <support@chilkatsoft.com>'';
  email.AddTo(''John Doe'',''jdoe@someplace.com'');
  email.Body := ''This is the body...'';

  ok := ChilkatMailMan21.SendEmail(email);
  if (ok = 0) then
        ChilkatMailMan21.SaveLastError(''errorLog.xml'');
  
end;

end' rule: #unitImplementation! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 11:26'!
testUnitInterface
	self parse: 'interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, CHILKATMAILLib2_TLB;

type
  TForm1 = class(TForm)
    ChilkatMailMan21: TChilkatMailMan2;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;' rule: #unitInterface! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/6/2012 13:51'!
testUsesIn
	(self parse: 'Unit1' rule: #usesIn)! !

!PPDelphiSyntaxTest methodsFor: 'tests' stamp: 'DiegoLont 9/13/2012 14:24'!
testUsesIn1
	(self parse: 'Unit1 in ''Unit1.pas''' rule: #usesIn)! !

!PPDelphiTest methodsFor: 'examples' stamp: 'DiegoLont 9/6/2012 15:23'!
program1
	^'program testProgram;

begin
end.'! !

!PPDelphiTest methodsFor: 'examples' stamp: 'DiegoLont 9/13/2012 14:08'!
program2
	^'program Project1;
uses
	Forms,
	Unit1 in ''Unit1.pas'' {Form1};
{$R *.RES}
begin
	Application.Initialize;
	Application.CreateForm(TForm1, Form1);
	Application.Run;
end.'! !

!PPDelphiTest methodsFor: 'examples' stamp: 'DiegoLont 9/6/2012 15:23'!
program3
	^'program Project1;

{$R *.RES}
begin
	Application.Initialize;
	Application.CreateForm(TForm1, Form1);
	Application.Run;
end.'! !

!PPDelphiTest methodsFor: 'examples' stamp: 'DiegoLont 9/20/2012 11:17'!
program4
	^'program WhiteStarUML;

const
  PERSONAL_EDITION = ''Personal'';
  TRIAL_EDITION = '''';
  COMMERCIAL_EDITION = '''';

var
  MainInstance: PMain;

begin
  Application.Initialize;
  Application.Run;
end.'! !

!PPDelphiTest methodsFor: 'examples' stamp: 'DiegoLont 9/6/2012 15:23'!
unit1
	^'unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, CHILKATMAILLib2_TLB;

type
  TForm1 = class(TForm)
    ChilkatMailMan21: TChilkatMailMan2;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  email: IChilkatEmail2;
  ok: Integer;

begin
  ChilkatMailMan21.UnlockComponent(''Anything for 30-day trial'');
  ChilkatMailMan21.SmtpHost := ''smtp.comcast.net'';

  email := ChilkatMailMan21.NewEmail();
  email.Subject := ''This is a test'';
  email.From := ''Chilkat Support <support@chilkatsoft.com>'';
  email.AddTo(''John Doe'',''jdoe@someplace.com'');
  email.Body := ''This is the body...'';

  ok := ChilkatMailMan21.SendEmail(email);
  if (ok = 0) then
        ChilkatMailMan21.SaveLastError(''errorLog.xml'');
  
end;

end.'! !

Object subclass: #PDASTNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitDelphi-AST'!

!PDASTNode methodsFor: 'visiting' stamp: 'DiegoLont 9/6/2012 15:18'!
acceptVisitor: aVisitor
	^self subclassResponsibility! !

PDASTNode subclass: #PDCompilationUnitNode
	instanceVariableNames: 'filename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitDelphi-AST'!

!PDCompilationUnitNode class methodsFor: 'instance creation' stamp: 'DiegoLont 9/13/2012 10:04'!
on: aFilename
	^self basicNew
		initialize: aFilename;
		yourself! !

!PDCompilationUnitNode methodsFor: 'visiting' stamp: 'DiegoLont 9/6/2012 15:20'!
acceptVisitor: aVisitor
	aVisitor acceptCompilationUnitNode: self! !

!PDCompilationUnitNode methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2012 10:03'!
filename
	^ filename! !

!PDCompilationUnitNode methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2012 10:03'!
filename: anObject
	filename := anObject! !

!PDCompilationUnitNode methodsFor: 'initialization' stamp: 'DiegoLont 9/13/2012 10:21'!
initialize: aFilename
	self initialize.
	self filename: aFilename.
	self parse! !

!PDCompilationUnitNode methodsFor: 'parsing' stamp: 'DiegoLont 9/13/2012 10:46'!
parse
	| filestream |
	filestream := StandardFileStream fileNamed: self filename.
	filestream 
		ifNil: [ self halt ]
		ifNotNil: [ self parse: (PPDelphiParser parse: filestream contents) ]! !

!PDCompilationUnitNode methodsFor: 'parsing' stamp: 'DiegoLont 9/13/2012 10:07'!
parse: aToken
	self subclassResponsibility! !

PDCompilationUnitNode subclass: #PDProgramNode
	instanceVariableNames: 'programName useClauses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitDelphi-AST'!

!PDProgramNode class methodsFor: 'instance creation' stamp: 'DiegoLont 9/13/2012 10:04'!
onTokens: aTokens
	^self basicNew
		initializeTokens: aTokens;
		yourself! !

!PDProgramNode methodsFor: 'converting' stamp: 'DiegoLont 9/6/2012 15:29'!
asString
	^super asString, '(', self programName asString, ')'! !

!PDProgramNode methodsFor: 'initialization' stamp: 'DiegoLont 9/13/2012 10:04'!
initializeTokens: aTokens
	self initialize.
	self programName: aTokens first.
	self useClauses: aTokens second! !

!PDProgramNode methodsFor: 'parsing' stamp: 'DiegoLont 9/13/2012 16:17'!
parse: aNode
	aNode isPetitFailure ifTrue: [ PDParseError signal: aNode asString ].
	(aNode isKindOf: self class)
		ifTrue: [
			self programName: aNode programName.
			self useClauses: aNode useClauses ]
		ifFalse: [ PDParseError signal: 'File is not a program' ].
! !

!PDProgramNode methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 15:21'!
programName
	^ programName! !

!PDProgramNode methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 15:21'!
programName: anObject
	programName := anObject! !

!PDProgramNode methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 15:48'!
unitNames
	self useClauses ifNil: [ ^#() ].
	^self useClauses collect: [ :each | each unitName ]! !

!PDProgramNode methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2012 15:53'!
units
	^self useClauses select: [ :each | each hasFile ] thenCollect: [ :each | each unit ]! !

!PDProgramNode methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 15:35'!
useClauses
	^ useClauses! !

!PDProgramNode methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 15:35'!
useClauses: anObject
	useClauses := anObject! !

PDCompilationUnitNode subclass: #PDUnitNode
	instanceVariableNames: 'unitName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitDelphi-AST'!

!PDUnitNode class methodsFor: 'instance creation' stamp: 'DiegoLont 9/13/2012 16:30'!
onTokens: aTokens 
	^self basicNew
		initializeTokens: aTokens;
		yourself! !

!PDUnitNode methodsFor: 'initialization' stamp: 'DiegoLont 9/13/2012 16:33'!
initializeTokens: aTokens
	self initialize.
	self unitName: aTokens second! !

!PDUnitNode methodsFor: 'parsing' stamp: 'DiegoLont 9/13/2012 16:18'!
parse: aNode
	aNode isPetitFailure ifTrue: [ PDParseError signal: aNode asString ].
	(aNode isKindOf: self class)
		ifTrue: [
			self unitName: aNode unitName ]
		ifFalse: [ PDParseError signal: 'File is not a unit' ].
! !

!PDUnitNode methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2012 10:03'!
unitName
	^ unitName! !

!PDUnitNode methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2012 10:03'!
unitName: anObject
	unitName := anObject! !

PDASTNode subclass: #PDUseClause
	instanceVariableNames: 'unitName filename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitDelphi-AST'!

!PDUseClause class methodsFor: 'instance creation' stamp: 'DiegoLont 9/6/2012 15:45'!
on: aUnitName
	^self new
		unitName: aUnitName;
		yourself! !

!PDUseClause class methodsFor: 'instance creation' stamp: 'DiegoLont 9/6/2012 15:45'!
on: aUnitName filename: aFilename
	^self new
		unitName: aUnitName;
		filename: aFilename;
		yourself! !

!PDUseClause methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 15:40'!
filename
	^ filename! !

!PDUseClause methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 15:40'!
filename: anObject
	filename := anObject! !

!PDUseClause methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2012 15:54'!
hasFile
	^filename notNil! !

!PDUseClause methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2012 15:53'!
unit
	^PDUnitNode on: ('../../../delphicode/', self filename)! !

!PDUseClause methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 15:40'!
unitName
	^ unitName! !

!PDUseClause methodsFor: 'accessing' stamp: 'DiegoLont 9/6/2012 16:04'!
unitName: anObject
	unitName := anObject! !

Error subclass: #PDParseError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitDelphi-AST'!
